package ru.alphatech.icfpc.game;

import ru.alphatech.icfpc.cards.I;


public class Slot
{
	private int _vitality = 10000;

	private IValue _value = new I();
	
	private int id = -1;
	
	public int getId() {
		return id;
	}

	public Slot(int id){
		if(id < 0 || id > 255)
			throw new ICFPCException();
		this.id = id;
	}
	
	public void setVitality(int vitality)
	{
		_vitality = vitality;
	}

	public int getVitality()
	{
		return _vitality;	
	}
	
	public boolean isZombie(){
		return _vitality == -1;
	}
	
	public boolean isDead(){
		return _vitality == 0 || _vitality == -1;
	}

	public IValue getValue()
	{
		return _value;
	}

	public void putValue(IValue value)
	{
		_value = value;
	}
	
	@Override
	public String toString()
	{
		return getId() + "={" + getVitality() + "," + getValue() + "}";
	}
}
