package ru.alphatech.icfpc.policy;

import java.util.ArrayList;

import ru.alphatech.icfpc.cards.Get;
import ru.alphatech.icfpc.cards.K;
import ru.alphatech.icfpc.cards.Put;
import ru.alphatech.icfpc.cards.S;
import ru.alphatech.icfpc.cards.Succ;
import ru.alphatech.icfpc.cards.Zero;
import ru.alphatech.icfpc.cards.Zombie;
import ru.alphatech.icfpc.game.AbstractPolicy;
import ru.alphatech.icfpc.game.Batch;
import ru.alphatech.icfpc.game.Run;
import ru.alphatech.icfpc.game.Slot;
import ru.alphatech.icfpc.game.Batch.OperationType;

public class ZombiePolicy extends AbstractPolicy {
	
	private int processingSlotIndex = -1;
	private int targetSlotIndex = -1;
	private int valueSlotIndex = -1;
	
	/**
	 * 
	 * @param processingSlotIndex - слот в котором выполниться процесс зомбирования =)
	 * @param targetSlot - слот который будет зомби
	 * @param valueSlot слот в котором лежит содержиме которое поместиться в зомби
	 */
	public ZombiePolicy(int processingSlotIndex, int targetSlot, int valueSlot) {
		this.processingSlotIndex = processingSlotIndex;
		this.targetSlotIndex = targetSlot;
		this.valueSlotIndex = valueSlot;
	}

	@Override
	public ArrayList<Batch> getBatches() {
		ArrayList<Batch> retArray = new ArrayList<Batch>();
		
		numberIntoSlotField(Run.getRegisterByIndex(1), targetSlotIndex);
		Slot processingSlot = Run.getProponent().getSlot(processingSlotIndex);
		
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new Put(), processingSlot));
		
		retArray.add(new Batch(OperationType.SLOT_TO_CARD, new Zombie(), processingSlot));
		
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new K(), processingSlot));
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new S(), processingSlot));
		
		retArray.add(new Batch(OperationType.SLOT_TO_CARD, new Get(), processingSlot));
		
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new K(), processingSlot));
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new S(), processingSlot));
		
		retArray.add(new Batch(OperationType.SLOT_TO_CARD, new Zero(), processingSlot));
		
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new K(), processingSlot));
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new S(), processingSlot));
		
		retArray.add(new Batch(OperationType.SLOT_TO_CARD, new Get(), processingSlot));
		
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new K(), processingSlot));
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new S(), processingSlot));
		
		retArray.add(new Batch(OperationType.SLOT_TO_CARD, new Succ(), processingSlot));
		
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new K(), processingSlot));
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new S(), processingSlot));
		
		retArray.add(new Batch(OperationType.SLOT_TO_CARD, new Zero(), processingSlot));
		
		return retArray;
	}

}
